Reintroduce setclock to write system clock to RTC at shutdown
[hvlinux.git] / stage1 / bootscripts / setclock
diff --git a/stage1/bootscripts/setclock b/stage1/bootscripts/setclock
new file mode 100755 (executable)
index 0000000..d07e135
--- /dev/null
@@ -0,0 +1,37 @@
+#!/bin/bash
+
+# setclock - Save system time value to hardware clock on shutdown and reboot
+
+# Source functions library
+source /etc/rc.d/init.d/functions
+
+log_script_name "$0 $*"
+
+# Load clock parameters
+source /etc/sysconfig/clock
+
+case "$UTC" in
+    yes|true|1)
+       TIME_BASE="--utc"
+       ;;
+    no|false|0)
+       TIME_BASE="--localtime"
+       ;;
+    *)
+        exit ${EXIT_CODE_FAILURE}
+       ;;
+esac
+
+# See how we were called
+case "$1" in
+    stop)
+       cmd_run_log_box "Saving system time value in hardware clock" \
+           /sbin/hwclock --systohc "$TIME_BASE"
+       ;;
+    *)
+       echo "Usage: $0 {stop}"
+        exit ${EXIT_CODE_FAILURE}
+       ;;
+esac
+
+exit $?